from typing import List, overload

from pyvrp.Individual import Individual
from pyvrp.PenaltyManager import PenaltyManager
from pyvrp.ProblemData import ProblemData
from pyvrp.XorShift128 import XorShift128

Neighbours = List[List[int]]

class LocalSearch:
    def __init__(
        self,
        data: ProblemData,
        penalty_manager: PenaltyManager,
        rng: XorShift128,
    ) -> None: ...
    def add_node_operator(self, op) -> None: ...
    def add_route_operator(self, op) -> None: ...
    def set_neighbours(self, neighbours: Neighbours) -> None: ...
    def get_neighbours(self) -> Neighbours: ...
    def intensify(self, individual: Individual) -> None: ...
    def search(self, individual: Individual) -> None: ...
